package examples;

import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.External.*;
//import uk.ac.ukc.cs.rwd.ConstraintDiagrams.AS.External.implementation.*;
//import uk.ac.ukc.cs.rwd.ConstraintDiagrams.AS.Internal.implementation.*;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.*;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.repository.*;
//import uk.ac.ukc.cs.rwd.ConstraintDiagrams.repository.implementation.*;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.startup.ConstraintDiagramsStartup$Class;
//import uk.ac.ukc.cs.kmf.ocl.implementations.*;

public class Venn2Example extends ConstraintDiagramsStartup$Class
{
    //--- Create SpiderDiagramrepository ---
    
    String ASIpath = "uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.";
    String ASEpath = "uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.External.";
    

    protected void replaceDefaultLifecycles() {
//        rep.addLifecycle(ASIpath+"Diagram", new lifecycle.AbstractDiagram(rep));    	        
    }
    
    //--- Populate repository ---
    protected void initialisePopulation() {
        Contour$Factory contour_lc = (Contour$Factory)(rep.getFactory(ASIpath+"Contour"));

        Diagram ad = (Diagram)rep.buildElement(ASIpath+"Diagram");

    	Contour c1 = (Contour)contour_lc.build();
    	Contour c2 = (Contour)contour_lc.build();
    	Contour c3 = (Contour)contour_lc.build();

        Zone z1 = (Zone)rep.buildElement(ASIpath+"Zone");
        Zone z2 = (Zone)rep.buildElement(ASIpath+"Zone");
        Zone z3 = (Zone)rep.buildElement(ASIpath+"Zone");
        Zone z4 = (Zone)rep.buildElement(ASIpath+"Zone");   	

    	c1.setDiagram(ad);
    	c1.setLabel("A&B");
    	c1.setBasicRegion(z1);
    	ad.getContour().add(c1);

    	c2.setLabel("A");
    	c2.setDiagram(ad);
    	c2.setBasicRegion(z2);
    	ad.getContour().add(c2);

    	c3.setLabel("B");
    	c3.setDiagram(ad);
    	c3.setBasicRegion(z3);
    	ad.getContour().add(c3);

        z1.setDiagram(ad);
        z1.setContour(c1);
        z1.getContainingContour().add(c1);
        z1.getContainingContour().add(c2);
        z1.getContainingContour().add(c3);
        z1.getContainingRegion().add(z1);        
        z1.getContainingRegion().add(z2);        
        z1.getContainingRegion().add(z3);        
        z1.getContainingRegion().add(z4);
        z1.getContainedZone().add(z1);
        ad.getZone().add(z1);
               
        z2.setDiagram(ad);
        z2.setContour(c2);
        z2.getContainingContour().add(c2);
        z2.getContainingRegion().add(z2);        
        z2.getContainingRegion().add(z4);        
        z2.getContainedZone().add(z2);
        z2.getContainedZone().add(z1);
        ad.getZone().add(z2);

        z3.setDiagram(ad);
        z3.setContour(c3);
        z3.getContainingContour().add(c3);
        z3.getContainingRegion().add(z3);        
        z3.getContainingRegion().add(z4);        
        z3.getContainedZone().add(z3);
        z3.getContainedZone().add(z1);
        ad.getZone().add(z3);

        z4.setDiagram(ad);
        z4.getContainingRegion().add(z4);        
        z4.getContainedZone().add(z1);
        z4.getContainedZone().add(z2);
        z4.getContainedZone().add(z3);
        z4.getContainedZone().add(z4);
        ad.getZone().add(z4);
     }
    //--- Main ---
    public static void main(String args[]) {
        (new Venn2Example()).run(new ConstraintDiagramsRepository$Class());
    }
}
